# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class OaiMetadataPrefixe(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'creation': 'ChangeInfo',
        'description': 'str',
        'enabled': 'bool',
        'last_update': 'ChangeInfo',
        'metadata_schema': 'str',
        'metadata_xml_transformation': 'str',
        'name': 'str',
        'prefix': 'str',
        'reference': 'bool',
        'res_id': 'str',
        'schema_namespace': 'str',
        'schema_url': 'str'
    }

    attribute_map = {
        'links': '_links',
        'creation': 'creation',
        'description': 'description',
        'enabled': 'enabled',
        'last_update': 'lastUpdate',
        'metadata_schema': 'metadataSchema',
        'metadata_xml_transformation': 'metadataXmlTransformation',
        'name': 'name',
        'prefix': 'prefix',
        'reference': 'reference',
        'res_id': 'resId',
        'schema_namespace': 'schemaNamespace',
        'schema_url': 'schemaUrl'
    }

    def __init__(self, links=None, creation=None, description=None, enabled=None, last_update=None, metadata_schema=None, metadata_xml_transformation=None, name=None, prefix=None, reference=None, res_id=None, schema_namespace=None, schema_url=None, local_vars_configuration=None):  # noqa: E501
        """OaiMetadataPrefixe - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._creation = None
        self._description = None
        self._enabled = None
        self._last_update = None
        self._metadata_schema = None
        self._metadata_xml_transformation = None
        self._name = None
        self._prefix = None
        self._reference = None
        self._res_id = None
        self._schema_namespace = None
        self._schema_url = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if creation is not None:
            self.creation = creation
        if description is not None:
            self.description = description
        if enabled is not None:
            self.enabled = enabled
        if last_update is not None:
            self.last_update = last_update
        if metadata_schema is not None:
            self.metadata_schema = metadata_schema
        if metadata_xml_transformation is not None:
            self.metadata_xml_transformation = metadata_xml_transformation
        if name is not None:
            self.name = name
        if prefix is not None:
            self.prefix = prefix
        if reference is not None:
            self.reference = reference
        if res_id is not None:
            self.res_id = res_id
        if schema_namespace is not None:
            self.schema_namespace = schema_namespace
        if schema_url is not None:
            self.schema_url = schema_url

    @property
    def links(self):
        """Gets the links of this OaiMetadataPrefixe.  # noqa: E501

        The _links_ list of the _oai-metadata-prefixes_ resource  # noqa: E501

        :return: The links of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this OaiMetadataPrefixe.

        The _links_ list of the _oai-metadata-prefixes_ resource  # noqa: E501

        :param links: The links of this OaiMetadataPrefixe.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def creation(self):
        """Gets the creation of this OaiMetadataPrefixe.  # noqa: E501


        :return: The creation of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this OaiMetadataPrefixe.


        :param creation: The creation of this OaiMetadataPrefixe.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def description(self):
        """Gets the description of this OaiMetadataPrefixe.  # noqa: E501

        The description of the OAI metadata prefix  # noqa: E501

        :return: The description of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this OaiMetadataPrefixe.

        The description of the OAI metadata prefix  # noqa: E501

        :param description: The description of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def enabled(self):
        """Gets the enabled of this OaiMetadataPrefixe.  # noqa: E501

        If the OAI metadata prefix is enable  # noqa: E501

        :return: The enabled of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this OaiMetadataPrefixe.

        If the OAI metadata prefix is enable  # noqa: E501

        :param enabled: The enabled of this OaiMetadataPrefixe.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def last_update(self):
        """Gets the last_update of this OaiMetadataPrefixe.  # noqa: E501


        :return: The last_update of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this OaiMetadataPrefixe.


        :param last_update: The last_update of this OaiMetadataPrefixe.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def metadata_schema(self):
        """Gets the metadata_schema of this OaiMetadataPrefixe.  # noqa: E501

        The XML schema of the OAI metadata prefix  # noqa: E501

        :return: The metadata_schema of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._metadata_schema

    @metadata_schema.setter
    def metadata_schema(self, metadata_schema):
        """Sets the metadata_schema of this OaiMetadataPrefixe.

        The XML schema of the OAI metadata prefix  # noqa: E501

        :param metadata_schema: The metadata_schema of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._metadata_schema = metadata_schema

    @property
    def metadata_xml_transformation(self):
        """Gets the metadata_xml_transformation of this OaiMetadataPrefixe.  # noqa: E501

        The XML transformation from reference metadata of the OAI metadata prefix  # noqa: E501

        :return: The metadata_xml_transformation of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._metadata_xml_transformation

    @metadata_xml_transformation.setter
    def metadata_xml_transformation(self, metadata_xml_transformation):
        """Sets the metadata_xml_transformation of this OaiMetadataPrefixe.

        The XML transformation from reference metadata of the OAI metadata prefix  # noqa: E501

        :param metadata_xml_transformation: The metadata_xml_transformation of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._metadata_xml_transformation = metadata_xml_transformation

    @property
    def name(self):
        """Gets the name of this OaiMetadataPrefixe.  # noqa: E501

        The name of the OAI metadata prefix  # noqa: E501

        :return: The name of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OaiMetadataPrefixe.

        The name of the OAI metadata prefix  # noqa: E501

        :param name: The name of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def prefix(self):
        """Gets the prefix of this OaiMetadataPrefixe.  # noqa: E501

        The specification of the OAI metadata prefix  # noqa: E501

        :return: The prefix of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix):
        """Sets the prefix of this OaiMetadataPrefixe.

        The specification of the OAI metadata prefix  # noqa: E501

        :param prefix: The prefix of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._prefix = prefix

    @property
    def reference(self):
        """Gets the reference of this OaiMetadataPrefixe.  # noqa: E501

        If the OAI metadata prefix is the reference metadata  # noqa: E501

        :return: The reference of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: bool
        """
        return self._reference

    @reference.setter
    def reference(self, reference):
        """Sets the reference of this OaiMetadataPrefixe.

        If the OAI metadata prefix is the reference metadata  # noqa: E501

        :param reference: The reference of this OaiMetadataPrefixe.  # noqa: E501
        :type: bool
        """

        self._reference = reference

    @property
    def res_id(self):
        """Gets the res_id of this OaiMetadataPrefixe.  # noqa: E501

        The _oai-metadata-prefixes_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this OaiMetadataPrefixe.

        The _oai-metadata-prefixes_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def schema_namespace(self):
        """Gets the schema_namespace of this OaiMetadataPrefixe.  # noqa: E501

        The XML schema namespace of the OAI metadata prefix  # noqa: E501

        :return: The schema_namespace of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._schema_namespace

    @schema_namespace.setter
    def schema_namespace(self, schema_namespace):
        """Sets the schema_namespace of this OaiMetadataPrefixe.

        The XML schema namespace of the OAI metadata prefix  # noqa: E501

        :param schema_namespace: The schema_namespace of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._schema_namespace = schema_namespace

    @property
    def schema_url(self):
        """Gets the schema_url of this OaiMetadataPrefixe.  # noqa: E501

        The XML schema URL of the OAI metadata prefix  # noqa: E501

        :return: The schema_url of this OaiMetadataPrefixe.  # noqa: E501
        :rtype: str
        """
        return self._schema_url

    @schema_url.setter
    def schema_url(self, schema_url):
        """Sets the schema_url of this OaiMetadataPrefixe.

        The XML schema URL of the OAI metadata prefix  # noqa: E501

        :param schema_url: The schema_url of this OaiMetadataPrefixe.  # noqa: E501
        :type: str
        """

        self._schema_url = schema_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OaiMetadataPrefixe):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OaiMetadataPrefixe):
            return True

        return self.to_dict() != other.to_dict()
